# Where documents are stored.  This affects where icons are placed.
%define contentdir /home/httpd

# The place where mailman binaries go.
%define mmdir /var/mailman

# The place where mutable data goes.
%define varmmdir /var/mailman

# The group the CGIs will expect to be run under.  This should match the
# group the web server is configured to run as. The scripts will error
# out if they are invoked by any other user.
%define cgigroup     httpd
%define cgigid       110

# The group your mail spoolers run as.
%define mailgroup    mailman
%define mailgid      41

# The user and group the scripts will actually execute as.
%define mmuser       mailman
%define mmuid        41
%define mmgroup      mailman
%define mmgid        41


Summary: Mailing list manager with built in Web access.
Name: mailman
Version: 2.1.3
Release: 1
Epoch: 3
Group: Applications/Internet
License: GPL
URL: http://www.list.org/
Packager: Hao Li <hli@haoli.org>
Source0: ftp://ftp.gnu.org/gnu/mailman/mailman-%{version}.tgz
Source2: mailman-README.REDHAT
Source3: httpd-mailman.conf
Source4: mailman.logrotate
BuildRoot: %{_tmppath}/%{name}-root
Prereq: shadow-utils, /usr/bin/newaliases, /usr/bin/crontab, /sbin/chkconfig, /sbin/service
Requires: apache, python >= 2.2.1, mktemp

%description 
Mailman is software to help manage email discussion lists, much like
Majordomo and Smartmail. Unlike most similar products, Mailman gives
each mailing list a webpage, and allows users to subscribe,
unsubscribe, etc. over the Web. Even the list manager can administer
his or her list entirely from the Web. Mailman also integrates most
things people want to do with mailing lists, including archiving, mail
<-> news gateways, and so on.


%prep
%setup -q
cat >> Mailman/mm_cfg.py.dist.in <<EOF
MTA = 'Postfix'
EOF
cp $RPM_SOURCE_DIR/mailman-README.REDHAT README.REDHAT


%build
# FIXME: mailman user and group must already exist at build time.
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS
MAIL_GID=%{mailgid} \
./configure \
	--prefix=%{mmdir} \
	--with-var-prefix=%{varmmdir} \
	--with-python=%{__python} \
	--with-mail-gid=%{mailgid} \
	--with-cgi-gid=%{cgigid} \
	--with-mailhost=localhost \
	--with-urlhost=localhost \
	--without-permcheck
make

	
%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT%{mmdir}/{cgi-bin,mail}/*

# Fix the permissions of some directories that fail check_perms
chmod 2775 $RPM_BUILD_ROOT%{mmdir}
chmod 2775 $RPM_BUILD_ROOT%{mmdir}/{messages,templates}/*

# Remove compiled python modules since they'll be recompiled at install time.
find $RPM_BUILD_ROOT%{mmdir} -name "*.pyc" -exec rm -f '{}' ';'

# Move the icons into the web server's icons directory.
mkdir -p $RPM_BUILD_ROOT%{contentdir}
mv $RPM_BUILD_ROOT/%{mmdir}/icons $RPM_BUILD_ROOT%{contentdir}/icons

# Install the mailman init.d script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mv $RPM_BUILD_ROOT%{mmdir}/scripts/mailman $RPM_BUILD_ROOT/etc/rc.d/init.d

# Install a logrotate control file.
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/mailman.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/mailman

# Install the httpd configuration file.
install -m755 -d $RPM_BUILD_ROOT/etc/httpd
sed -e 's|@VARMMDIR@|%{varmmdir}|g' -e 's|@MMDIR@|%{mmdir}|g' \
	$RPM_SOURCE_DIR/httpd-mailman.conf > \
	$RPM_BUILD_ROOT/etc/httpd/mailman.conf
chmod 644 $RPM_BUILD_ROOT/etc/httpd/mailman.conf


%pre
/usr/sbin/groupadd -g %{mmgid} -r -f %{mmgroup} 2>/dev/null || :
/usr/sbin/useradd -c "Mailman" -r -n -M -s /bin/false \
    -u %{mmuid} -g %{mmgid} -d %{mmdir} %{mmuser} 2>/dev/null || :


%post
# Recompile python modules
find %{mmdir} -name "*.pyc" -exec rm -f '{}' ';'
%{__python} -c 'from compileall import *; compile_dir("%{mmdir}",10,"%{mmdir}")' > /dev/null 2>&1 

crontab -u %{mmuser} %{mmdir}/cron/crontab.in


%preun
if [ $1 = 0 ]; then
  /sbin/service mailman stop
  /sbin/chkconfig --del mailman
  find %{mmdir} -name "*.pyc" -exec rm -f '{}' ';'
  crontab -u %{mmuser} -r
fi


%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS BUGS FAQ INSTALL NEWS README* TODO UPGRADING
%attr(-,root,%{mmgroup}) %{mmdir}
%{contentdir}/icons
%config /etc/rc.d/init.d/mailman
%config /etc/logrotate.d/mailman
%config /etc/httpd/mailman.conf


%clean
rm -rf $RPM_BUILD_ROOT

